var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
  else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { MapToComponentField, MapToComponentMethod, VegaSlimmer } from 'vega-slimmer/core';
import { VegaModalSectionPaddingState } from '../models/vega-modal-section-padding-state';
/**
 * Modal section padding state controller
 */
export class VegaModalPaddingStateController extends VegaSlimmer {
  /**
   * Component lifecycle - [componentWillLoad]
   */
  componentWillLoad() {
    this.setSectionPaddingState();
  }
  /**
   * Watch for changes in padding and update the section padding state accordingly.
   */
  watchPadding() {
    this.setSectionPaddingState();
  }
  /**
   * Set the section padding state based on the current padding prop.
   */
  setSectionPaddingState() {
    this.sectionPaddingState = new VegaModalSectionPaddingState(this.padding);
  }
}
__decorate([
  MapToComponentField({ writable: true })
], VegaModalPaddingStateController.prototype, "sectionPaddingState", void 0);
__decorate([
  MapToComponentField()
], VegaModalPaddingStateController.prototype, "padding", void 0);
__decorate([
  MapToComponentMethod('componentWillLoad')
], VegaModalPaddingStateController.prototype, "componentWillLoad", null);
__decorate([
  MapToComponentMethod('watchPadding')
], VegaModalPaddingStateController.prototype, "watchPadding", null);
